/*
 * Part of winebottle 0.1.  See file COPYING for notices and license.
 *
 * Authors : Johan Ceuppens
 */

#ifndef _LA_MAPITERATOR_H_
#define _LA_MAPITERATOR_H_

#include <iterator>
#include "map.h"

class MapIterator : public std::iterator<std::input_iterator_tag, int>
{
  int* p;
public:
  MapIterator(int* x) :p(x) {}
  MapIterator(const MapIterator& mit) : p(mit.p) {}
  MapIterator& operator++() {++p;return *this;}
  MapIterator operator++(int) {MapIterator tmp(*this); operator++(); return tmp;}
  bool operator==(const MapIterator& rhs) {return p==rhs.p;}
  bool operator!=(const MapIterator& rhs) {return p!=rhs.p;}
  int& operator*() {return *p;}
};

#endif
